﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using BookApi.Models;
using BookApi.Repositories;

namespace BookApi.Controllers
{
    public class BooksController : ApiController
    {
        BookRepository repository = new BookRepository();

        // GET api/books
        public HttpResponseMessage Get()
        {
            return Request.CreateResponse(HttpStatusCode.OK, repository.FindAll());
        }

        // GET api/books/5
        public HttpResponseMessage Get(int id)
        {
            var book = repository.Find(id);
            if (book != null)
                return Request.CreateResponse(HttpStatusCode.OK, book);
            else
                return Request.CreateResponse(HttpStatusCode.NotFound, "book not found");
        }

        // POST api/books
        public HttpResponseMessage Post([FromBody]Book book)
        {
            var b = repository.Add(book);
            return Request.CreateResponse(HttpStatusCode.Created, b);
        }

        // PUT api/books/5
        public HttpResponseMessage Put(int id, [FromBody]Book book)
        {
            repository.Update(id, book);
            return Request.CreateResponse(HttpStatusCode.OK, "resource updated successfully");
        }

        // DELETE api/books/5
        public HttpResponseMessage Delete(int id)
        {
            repository.Remove(id);
            return Request.CreateResponse(HttpStatusCode.NoContent, "Book has been deleted");
        }
    }
}
