﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using BookApi.Models;

namespace BookApi.Repositories
{
    public class BookRepository
    {
        private int counter = 10;
        private List<Book> Books = new List<Book>
        {
            new Book {ID = 1, Title = "Obcy", Author = "Albert Camus", Year = 1942},
            new Book {ID= 2, Title= "Proces", Author= "Franz Kafka", Year= 1925},
            new Book {ID= 3, Title= "Mały Książę", Author= "Antoine de Saint-Exupéry", Year= 1943},
            new Book {ID= 4, Title= "Grona gniewu", Author= "John Steinbeck", Year= 1939},
            new Book {ID= 5, Title= "Komu bije dzwon", Author= "Ernest Hemingway", Year= 1940},
            new Book {ID= 6, Title= "Rok 1984", Author= "George Orwell", Year= 1949},
            new Book {ID= 7, Title= "Mistrz i Małgorzata", Author= "", Year= 1967},
            new Book {ID= 8, Title= "Imię róży", Author= "Umberto Eco", Year= 1980},
            new Book {ID= 9, Title= "Czarodziejska Góra", Author= "Tomasz Mann", Year= 1924},
            new Book {ID= 10, Title= "Dzieci północy", Author= "Salman Rushdie", Year= 1981}
        };

        public List<Book> FindAll()
        {
            return Books;
        }

        public Book Find(int id)
        {
            return Books.Find(e => e.ID == id);
        }

        public Book Add(Book book)
        {
            book.ID = ++counter;
            Books.Add(book);
            return book;
        }

        public Book Update(int id, Book book)
        {
            var b = Books.Find(e => e.ID == id);
            if (b!= null)
            {
                if (!string.IsNullOrEmpty(b.Title)) b.Title = book.Title;
                if (!string.IsNullOrEmpty(b.Author)) b.Author = book.Author;
                if (b.Year>0) b.Year = book.Year;
            }
            return b;
        }

        public void Remove(int id)
        {
            Books.RemoveAll(e => e.ID == id);
        }
    }
}